
//
// Academic License - for use in teaching, academic research, and meeting
// course requirements at degree granting institutions only.  Not for
// government, commercial, or other organizational use.
// File: kin_xyzbc_tt_JP_tj.cpp
//
// MATLAB Coder version            : 5.4
//

// Include Files
#include "kin_xyzbc_tt_JP_tj.h"
#include "coder_array.h"
#include <cmath>

// Function Definitions
//
// function JP_tj = kin_xyzbc_tt_JP_tj(in1,in2,in3)
//
// kin_xyzbc_tt_JP_tj
//     JP_tj = kin_xyzbc_tt_JP_tj(IN1,IN2,IN3)
//
// Arguments    : const ::coder::array<double, 1U> &in1
//                const ::coder::array<double, 1U> &in2
//                const ::coder::array<double, 1U> &in3
//                double JP_tj[5][5]
// Return Type  : void
//
namespace ocn {
void kin_xyzbc_tt_JP_tj(const ::coder::array<double, 1U> &in1,
                        const ::coder::array<double, 1U> &in2,
                        const ::coder::array<double, 1U> &in3, double JP_tj[5][5])
{
    double b_in2[25];
    double b_in2_tmp;
    double c_in2_tmp;
    double d_in2_tmp;
    double e_in2_tmp;
    double f_in2_tmp;
    double in2_tmp;
    double t10;
    double t11;
    double t12_tmp;
    double t13;
    double t13_tmp;
    double t15_tmp;
    double t18;
    double t18_tmp;
    double t2;
    double t21;
    double t22;
    double t3;
    double t4;
    double t5;
    double t9;
    //     This function was generated by the Symbolic Math Toolbox version 9.1.
    //     07-Nov-2023 14:54:36
    // Jacobian first derivative ( Forward Kinematics ) :
    // INPUTS :
    // 	r_j    (5x1) : pose vector( joint space )
    // 	v_j    (5x1) : speed vector( joint space )
    // 	a_j    (5x1) : acceleration vector( joint space )
    // 	p      (3x5) : parameters
    // OUTPUTS :
    // 	M      (5x5) : resulting matrix
    // 'kin_xyzbc_tt_JP_tj:17' b = in1(4,:);
    // 'kin_xyzbc_tt_JP_tj:18' c = in1(5,:);
    // 'kin_xyzbc_tt_JP_tj:19' jp1 = in2(1,:);
    // 'kin_xyzbc_tt_JP_tj:20' jp2 = in2(2,:);
    // 'kin_xyzbc_tt_JP_tj:21' jp3 = in2(3,:);
    // 'kin_xyzbc_tt_JP_tj:22' jp4 = in2(4,:);
    // 'kin_xyzbc_tt_JP_tj:23' jp5 = in2(5,:);
    // 'kin_xyzbc_tt_JP_tj:24' offB1 = in3(10);
    // 'kin_xyzbc_tt_JP_tj:25' offB2 = in3(11);
    // 'kin_xyzbc_tt_JP_tj:26' offC1 = in3(13);
    // 'kin_xyzbc_tt_JP_tj:27' offB3 = in3(12);
    // 'kin_xyzbc_tt_JP_tj:28' offC2 = in3(14);
    // 'kin_xyzbc_tt_JP_tj:29' offC3 = in3(15);
    // 'kin_xyzbc_tt_JP_tj:30' offM1 = in3(1);
    // 'kin_xyzbc_tt_JP_tj:31' offM2 = in3(2);
    // 'kin_xyzbc_tt_JP_tj:32' offM3 = in3(3);
    // 'kin_xyzbc_tt_JP_tj:33' offT1 = in3(4);
    // 'kin_xyzbc_tt_JP_tj:34' offT2 = in3(5);
    // 'kin_xyzbc_tt_JP_tj:35' offT3 = in3(6);
    // 'kin_xyzbc_tt_JP_tj:36' x = in1(1,:);
    // 'kin_xyzbc_tt_JP_tj:37' y = in1(2,:);
    // 'kin_xyzbc_tt_JP_tj:38' z = in1(3,:);
    // 'kin_xyzbc_tt_JP_tj:39' t2 = cos(b);
    t2 = std::cos(in1[3]);
    // 'kin_xyzbc_tt_JP_tj:40' t3 = cos(c);
    t3 = std::cos(in1[4]);
    // 'kin_xyzbc_tt_JP_tj:41' t4 = sin(b);
    t4 = std::sin(in1[3]);
    // 'kin_xyzbc_tt_JP_tj:42' t5 = sin(c);
    t5 = std::sin(in1[4]);
    // 'kin_xyzbc_tt_JP_tj:43' t6 = -offM1;
    // 'kin_xyzbc_tt_JP_tj:44' t7 = -offM2;
    // 'kin_xyzbc_tt_JP_tj:45' t8 = -offM3;
    // 'kin_xyzbc_tt_JP_tj:46' t9 = offB1+offC1+offT1+t6+x;
    t9 = (((in3[9] + in3[12]) + in3[3]) + -in3[0]) + in1[0];
    // 'kin_xyzbc_tt_JP_tj:47' t10 = offB2+offC2+offT2+t7+y;
    t10 = (((in3[10] + in3[13]) + in3[4]) + -in3[1]) + in1[1];
    // 'kin_xyzbc_tt_JP_tj:48' t11 = offB3+offC3+offT3+t8+z;
    t11 = (((in3[11] + in3[14]) + in3[5]) + -in3[2]) + in1[2];
    // 'kin_xyzbc_tt_JP_tj:49' t12 = t4.*t5.*t11;
    t12_tmp = t4 * t5;
    // 'kin_xyzbc_tt_JP_tj:50' t13 = t2.*t3.*t9;
    t13_tmp = t2 * t3;
    t13 = t13_tmp * t9;
    // 'kin_xyzbc_tt_JP_tj:51' t14 = t2.*t3.*t11;
    // 'kin_xyzbc_tt_JP_tj:52' t15 = t2.*t5.*t9;
    t15_tmp = t2 * t5;
    // 'kin_xyzbc_tt_JP_tj:53' t16 = t3.*t4.*t9;
    // 'kin_xyzbc_tt_JP_tj:54' t17 = t2.*t5.*t11;
    // 'kin_xyzbc_tt_JP_tj:55' t18 = t3.*t4.*t11;
    t18_tmp = t3 * t4;
    t18 = t18_tmp * t11;
    // 'kin_xyzbc_tt_JP_tj:56' t19 = t4.*t5.*t9;
    // 'kin_xyzbc_tt_JP_tj:57' t20 = -t15;
    // 'kin_xyzbc_tt_JP_tj:58' t21 = t14+t16;
    t21 = t13_tmp * t11 + t18_tmp * t9;
    // 'kin_xyzbc_tt_JP_tj:59' t22 = t17+t19;
    t22 = t15_tmp * t11 + t12_tmp * t9;
    // 'kin_xyzbc_tt_JP_tj:60' mt1 =
    // [-jp4.*t3.*t4-jp5.*t2.*t5,-jp5.*t2.*t3+jp4.*t4.*t5,jp4.*t2,0.0,0.0,jp5.*t3,-jp5.*t5,0.0,0.0,0.0,-jp4.*t2.*t3+jp5.*t4.*t5,jp4.*t2.*t5+jp5.*t3.*t4,-jp4.*t4,0.0,0.0,jp5.*t22-jp4.*(t13-t18)-jp1.*t3.*t4-jp3.*t2.*t3,-jp4.*(t12+t20)+jp5.*t21+jp1.*t4.*t5+jp3.*t2.*t5,jp1.*t2-jp3.*t4-jp4.*(t2.*t11+t4.*t9),0.0,0.0,jp5.*(-t13+t18+offB1.*t3+offB2.*t5-t5.*t10)+jp2.*t3+jp4.*t22-jp1.*t2.*t5+jp3.*t4.*t5];
    // 'kin_xyzbc_tt_JP_tj:61' mt2 =
    // [-jp2.*t5+jp4.*t21-jp5.*(t12+t20-offB2.*t3+offB1.*t5+t3.*t10)-jp1.*t2.*t3+jp3.*t3.*t4,0.0,0.0,0.0];
    // 'kin_xyzbc_tt_JP_tj:62' JP_tj = reshape([mt1,mt2],5,5);
    b_in2[0] = -in2[3] * t3 * t4 - in2[4] * t2 * t5;
    b_in2[1] = -in2[4] * t2 * t3 + in2[3] * t4 * t5;
    in2_tmp = in2[3] * t2;
    b_in2[2] = in2_tmp;
    b_in2[3] = 0.0;
    b_in2[4] = 0.0;
    b_in2_tmp = in2[4] * t3;
    b_in2[5] = b_in2_tmp;
    b_in2[6] = -in2[4] * t5;
    b_in2[7] = 0.0;
    b_in2[8] = 0.0;
    b_in2[9] = 0.0;
    b_in2[10] = -in2[3] * t2 * t3 + in2[4] * t4 * t5;
    b_in2[11] = in2_tmp * t5 + b_in2_tmp * t4;
    b_in2[12] = -in2[3] * t4;
    b_in2[13] = 0.0;
    b_in2[14] = 0.0;
    c_in2_tmp = in2[2] * t2;
    b_in2[15] = ((in2[4] * t22 - in2[3] * (t13 - t18)) - in2[0] * t3 * t4) - c_in2_tmp * t3;
    d_in2_tmp = t12_tmp * t11 + -(t15_tmp * t9);
    b_in2[16] = ((-in2[3] * d_in2_tmp + in2[4] * t21) + in2[0] * t4 * t5) + c_in2_tmp * t5;
    e_in2_tmp = in2[0] * t2;
    f_in2_tmp = in2[2] * t4;
    b_in2[17] = (e_in2_tmp - f_in2_tmp) - in2[3] * (t2 * t11 + t4 * t9);
    b_in2[18] = 0.0;
    b_in2[19] = 0.0;
    b_in2[20] =
        (((in2[4] * ((((-t13 + t18) + in3[9] * t3) + in3[10] * t5) - t5 * t10) + in2[1] * t3) +
          in2[3] * t22) -
         e_in2_tmp * t5) +
        f_in2_tmp * t5;
    b_in2[21] = (((-in2[1] * t5 + in2[3] * t21) -
                  in2[4] * (((d_in2_tmp - in3[10] * t3) + in3[9] * t5) + t3 * t10)) -
                 e_in2_tmp * t3) +
                in2[2] * t3 * t4;
    b_in2[22] = 0.0;
    b_in2[23] = 0.0;
    b_in2[24] = 0.0;
    for (int i{0}; i < 5; i++) {
        for (int i1{0}; i1 < 5; i1++) {
            JP_tj[i][i1] = b_in2[i1 + 5 * i];
        }
    }
}

} // namespace ocn

//
// File trailer for kin_xyzbc_tt_JP_tj.cpp
//
// [EOF]
//
